package com.zoo.ThreadTest;

import java.util.concurrent.*;

public class Test1 {
    public static void main(String[] args) {
        //CompletableFuture默认线程池是守护线程
        ExecutorService executorService = Executors.newFixedThreadPool(3);
        CompletableFuture.supplyAsync(()->{
            System.out.println(Thread.currentThread().getName() + "...come in");
            int result = ThreadLocalRandom.current().nextInt(10);
            try{
                TimeUnit.SECONDS.sleep(1);
            }catch (InterruptedException e){
                e.printStackTrace();
            }
            System.out.println("--1秒钟出结果"+result);
            return result;
        },executorService).whenComplete((v,e)->{
            if (e==null){
                System.out.println("==计算完成，更新系统updateValue"+v);
            }
        }).exceptionally(e->{
            e.printStackTrace();
            System.out.println("异常情况"+e.getCause()+"\t" + e.getMessage());
            return null;
        });
        System.out.println(Thread.currentThread().getName()+"线程先去忙其他任务");
//        try {
//            TimeUnit.SECONDS.sleep(3);
//        } catch (InterruptedException e) {
//            throw new RuntimeException(e);
//        }
    }
}
